/*
 * IBM Confidential
 * OCO Source Materials
 * IBM(R) WebSphere(R) Business Integration Adapters, 5724-D17
 * (C) Copyright IBM Corp. 1997, 2002 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */

/*
 * IBM Confidential
 * OCO Source Materials
 * IBM(R) CrossWorlds(R) Connectors(R), 5724-C11
 * (C) Copyright IBM Corp. 1997-2002 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */

package bapi.server;

/**
 * Copyright:    Copyright (c)
 * Company: CROSSWORLDS SOFTWARE INC.
 * @author  Zafrulla Khan
 * @version 1.0
 */

// Crossworlds classes
import CxCommon.CxStatusConstants;

import com.crossworlds.connectors.sap.visionframework.SapConnectorUtil;

import com.sap.mw.jco.JCO;


public class RfcServerExceptionHandler {

  /**                                                       *
   * YOU CAN MODIFY THE CODE BELOW THIS TO SUITE YOUR NEEDS *
   *                                                        */

  /**
   * You can change the following code to suite your needs for handling functions
   * that are not installed in the JCO repository.  This method is called within
   * the handleRequest() method for a JCO Server whenever a JCO function is not
   * installed.
   * By default, an exception is raised that causes a short dump within SAP.
   *
   * Notes:
   * 1. CxStatusConstants.SUCCEED indicates that not having this function is
   *    acceptable.
   * 2. CxStatusConstants.FAIL indicates that a failure is sent back to SAP by
   *    creating a short dump within SAP.  However the server thread will remain
   *    alive along with the connector.
   * 3. CxStatusConstants.APPRESPONSETIMEOUT indicates that a failure is sent back
   *    to SAP by creating a short dump with SAP.  Both the server thread and
   *    connector are terminated.
   */

   /**
    * Do not remove this method. This method is called by handleRequest().
    */

  public int noServerFunctionException (JCO.Function pFunction) {

    // There may be server functions called that do not exist and should not cause
    // an error to be returned, e.g. BAPI_TRANSACTION_COMMIT.
//    if (pFunction.getName().equalsIgnoreCase("BAPI_TRANSACTION_COMMIT"))
//      return CxStatusConstants.SUCCEED;

    // Returning a fail will cause a short dump in SAP but the server thread will
    // continue to run.
    return CxStatusConstants.FAIL;

    // Returning an appresponsetimeout will cause a short dump in SAP and also kill
    // the connector on the next poll call.
//    return CxStatusConstants.APPRESPONSETIMEOUT;

  }

}